// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/slok/kube-code-generator/example/apis/comic/v1"
	scheme "github.com/slok/kube-code-generator/example/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// HerosGetter has a method to return a HeroInterface.
// A group's client should implement this interface.
type HerosGetter interface {
	Heros() HeroInterface
}

// HeroInterface has methods to work with Hero resources.
type HeroInterface interface {
	Create(ctx context.Context, hero *v1.Hero, opts metav1.CreateOptions) (*v1.Hero, error)
	Update(ctx context.Context, hero *v1.Hero, opts metav1.UpdateOptions) (*v1.Hero, error)
	UpdateStatus(ctx context.Context, hero *v1.Hero, opts metav1.UpdateOptions) (*v1.Hero, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.Hero, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.HeroList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.Hero, err error)
	HeroExpansion
}

// heros implements HeroInterface
type heros struct {
	client rest.Interface
}

// newHeros returns a Heros
func newHeros(c *ComicV1Client) *heros {
	return &heros{
		client: c.RESTClient(),
	}
}

// Get takes name of the hero, and returns the corresponding hero object, and an error if there is any.
func (c *heros) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.Hero, err error) {
	result = &v1.Hero{}
	err = c.client.Get().
		Resource("heros").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Heros that match those selectors.
func (c *heros) List(ctx context.Context, opts metav1.ListOptions) (result *v1.HeroList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.HeroList{}
	err = c.client.Get().
		Resource("heros").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested heros.
func (c *heros) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("heros").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a hero and creates it.  Returns the server's representation of the hero, and an error, if there is any.
func (c *heros) Create(ctx context.Context, hero *v1.Hero, opts metav1.CreateOptions) (result *v1.Hero, err error) {
	result = &v1.Hero{}
	err = c.client.Post().
		Resource("heros").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(hero).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a hero and updates it. Returns the server's representation of the hero, and an error, if there is any.
func (c *heros) Update(ctx context.Context, hero *v1.Hero, opts metav1.UpdateOptions) (result *v1.Hero, err error) {
	result = &v1.Hero{}
	err = c.client.Put().
		Resource("heros").
		Name(hero.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(hero).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *heros) UpdateStatus(ctx context.Context, hero *v1.Hero, opts metav1.UpdateOptions) (result *v1.Hero, err error) {
	result = &v1.Hero{}
	err = c.client.Put().
		Resource("heros").
		Name(hero.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(hero).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the hero and deletes it. Returns an error if one occurs.
func (c *heros) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("heros").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *heros) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("heros").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched hero.
func (c *heros) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.Hero, err error) {
	result = &v1.Hero{}
	err = c.client.Patch(pt).
		Resource("heros").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
